//==================================================================//
//==================  =  1.0 = (04.01.2011) ==========//
//==================================================================//
//    :                                    //
// 1. Usart_Write_Str -    USART                 //
// 2. Usart_WriteLn_Str -    USART +  //
// 3. strConstCopy -    ROM  RAM                //
//==================================================================//

extern void Usart_Write_Str (char* string);
extern void Usart_WriteLn_Str (char* string);

extern void strConstCopy (char *dest, const char *source);

//==================================================================//
//================== Put string to USART ===========================//
//==================================================================//
void Usart_Write_Str (char* string) {
 while (strlen(string)) {
  Uart1_Write((char) (*string));
  ++string;
 }
}

void Usart_WriteLn_Str (char* string) {
 Usart_Write_Str (string);
 Uart1_Write(0x0D);
 Uart1_Write(0x0A);
}

//==================================================================//
//================== Copy string from ROM to RAM ===================//
//==================================================================//
void strConstCopy (char *dest, const char *source) {
 while (*source) *dest++ = *source++;
 *dest = 0;
}